Placement: Difference between revisions

From FreeCAD Documentation
(tag </ translate> wrong??)
Line 212: Line 212:
</translate>
</translate>
<br>
<br>
{{languages | {{fr|Placement/fr}} {{it|Placement/it}} }}
{{languages | {{es|Placement/es}} {{fr|Placement/fr}} {{it|Placement/it}} }}


[[Category:User Documentation]]
[[Category:User Documentation]]

Revision as of 21:49, 5 October 2013

Overview

Placement is how FreeCAD specifies the location and attitude (orientation) of an object in space. Placement can be specified in multiple forms and manipulated via scripting, the Properties pane or the Placement dialog (Edit menu).

Accessing the Placement Attribute

An object's Placement attributes can be accessed and modified in 3 ways:

Placement in Properties panel
Scripting Placement as y/p/r and Matrix and its API.
Placement Dialog


Forms of Placement

Angle, Axis and Position

Placement = [Angle, Axis, Position]

The first form of Placement fixes an object's location in space with a Position, and describes it's orientation as a single rotation about an axis.

Angle = r is a scalar indicating the amount of rotation of the object about Axis. Entered as degrees, but stored internally as radians.

Axis = (ax,ay,az) is a vector describing an axis of rotation (See Note about axis of rotation). Examples are:

   (1,0,0)       ==> about X axis
   (0,1,0)       ==> about Y axis
   (0,0,1)       ==> about Z axis
   (0.71,0.71,0) ==> about the line y=x
                                        

Position = (x,y,z) is a Vector describing the world coordinates of the reference point of the object. Note that in scripts, Placement.Base is used to denote the Position component of a placement. The Property Editor calls this value "Position".


Position and Yaw, Pitch and Roll

Placement = [Position, Yaw-Pitch-Roll]

The second form of Placement fixes an object's location in space with a Position (as in the first form), but describes it's orientation using Yaw, Pitch and Roll angles (Yaw, Pitch, Roll). These angles are sometimes referred to as Euler angles or Tait-Bryan angles (Euler angles). Yaw, Pitch and Roll are common aviation terms for a body's orientation (or attitude).

Position = (x,y,z) is a Vector describing the world coordinates of the reference point of the object.

Yaw-Pitch-Roll = (y,p,r) is a tuple that specifies the attitude of the object. Values for y,p,r specify degrees of rotation about each of the z,y,x axis (see note).


Matrix

Placement = Matrix

The third form of Placement describes the object's position and orientation with a 4x4 affine transformation matrix (Affine Transformation).

Matrix =

  ((r11,r12,r13,t1),
   (r21,r22,r23,t2),
   (r31,r32,r33,t3),
   (0,0,0,1)) , with rij specifying rotation and ti specifying translation.


The Placement Dialog

The Placement Dialog is invoked from the Edit menu. It is used to precisely rotate/translate objects. It is also used when we need to create a sketch on a "non standard" plane or change a sketch's orientation to a new plane.

The Translation section adjusts the objects location in space. The Center section adjusts the rotational axis to one that does not pass through the object's reference point. The Rotation section adjusts the rotational angle(s) and the method of specifying those angles.

The Apply incremental changes to object placement tick box is useful when translations/rotations are to be made relative the object's current position/attitude, rather than to the original position/attitude. Ticking this box resets the dialog's input fields to zero, but does not change the object's orientation or location. Subsequent entries do change the orientation/location, but are applied from the object's current position.


Examples

Rotations about a single axis:

Before Rotation
Before Rotation

Before Rotation (top view)


After Rotation about Z
After Rotation about Z

After Rotation about Z (top view)


After Rotation about y=x
After Rotation about y=x

After Rotation about y=x (right view)



Rotation with offset centre point:

Before Rotation
Before Rotation

Before Rotation (top view)


After Rotation about Z
After Rotation about Z

After Rotation about Z (top view)



Rotation using Euler angles:

Before Rotation
Before Rotation

Before Rotation


After Rotation
After Rotation

After Rotation


Placement.Base vs Shape Definition

Placement is not the only way to position a shape in space. Note the Python console in this image:

2 Shapes with Same Placement

Both cubes have the same value for Placement, but are in different locations! This is because the 2 shapes are defined by different vertices. For the 2 shapes in the above illustration:

 >>> ev = App.ActiveDocument.Extrude.Shape.Vertexes
 >>> for v in ev: print v.X,",",v.Y,",",v.Z
 ... 
 30.0,30.0,0.0
 30.0,30.0,10.0
 40.0,30.0,0.0
 40.0,30.0,10.0
 40.0,40.0,0.0
 40.0,40.0,10.0
 30.0,40.0,0.0
 30.0,40.0,10.0
 >>> e1v = App.ActiveDocument.Extrude001.Shape.Vertexes
 >>> for v in e1v: print v.X,",",v.Y,",",v.Z
 ... 
 0.0,10.0,0.0
 0.0,10.0,10.0
 10.0,10.0,0.0
 10.0,10.0,10.0
 10.0,0.0,0.0
 10.0,0.0,10.0
 0.0,0.0,0.0
 0.0,0.0,10.0
 >>> 
 

The Vertices (or Vectors) that define the shape use the Placement.Base attribute as their origin. So if you want to move a shape 10 units along the X axis, you could add 10 to the X coordinates of all the Vertices or you could set Placement.Position to (10,0,0).


Using "Center" to Control Axis of Rotation

By default, the axis of rotation isn't really the x/y/z axis. It is a line parallel to the selected axis, but passing through the reference point (Placement.Base) of the object to be rotated. This can be changed by using the Center fields in the Placement dialog or, in scripts, by using the Center parameter of the FreeCAD.Placement constructor.

For example, suppose we have a box (below) positioned at (20,20,10).

Before Rotation

We wish to spin the box around it's own vertical centre line (ie local Z), while keeping it the same position. We can easily achieve this by specifying a Center value equal to the coordinates of the box's central point (25,25,15).

After Rotation


In a script, we would do:

 obj = App.ActiveDocument.Box                       # our box
 rot = FreeCAD.Rotation(FreeCAD.Vector(0,0,1),45)   # 45° about Z
 centre = FreeCAD.Vector(25,25,15)                  # central point of box 
 pos = obj.Placement.Base                           # position point of box
 newplace = FreeCAD.Placement(pos,rot,centre)       # make a new Placement object
 obj.Placement = newplace                           # spin the box


Notes

  • Axis and Angle can also be expressed as a quaternion.
  • The reference point of an object (FreeCAD.Placement.Base) varies depending on the object. Some examples for common objects:


Object Reference Point
Part.Box left (minx), front (miny), bottom (minz) vertex
Part.Sphere center of the sphere (ie centre of bounding box)
Part.Cylinder center of the bottom face
Part.Cone center of bottom face (or apex if bottom radius is 0)
Part.Torus center of the torus
Features derived from Sketches the Feature inherits the Position of the underlying Sketch. Sketches always start with Position = (0,0,0).


Issues

  • As of version 0.13, update of Placement properties in the Data tab has been disabled for objects created with PartDesign, except for the initial sketch from which the solid will be created. Therefore the Placement of a solid created in PartDesign from a sketch can only be altered by adjusting Placement parameters of the initial construction sketch (the first sketch) from which the solid was created.
  • Placement functionality will eventually be handled in the Assembly workbench.


More

  • This tutorial: Aeroplane covers the mechanics of changing an object's Placement extensively.
  • A step-by-step explanation of the Placement Dialog can be found here Tasks_Placement.


Available translations of this page: